﻿#light

let nagyobb (x:int) y:int =
    match x with
    | _ when x<y -> y
    | _ when x>y -> x
    | otherwise -> x

type Tree<'a>=
    | Node of Tree<'a> * Tree<'a> * 'a
    | Leaf
    member x.Depth =
        match x with
        | Leaf -> 0
        | Node(ls,rs,_) -> nagyobb ls.Depth rs.Depth + 1

let avlProperty (tree:Tree<'a>)=
    match tree with 
    | Node(ls,rs,_) -> abs (ls.Depth - rs.Depth) <=1
    | _ -> false

let pp (tree:Tree<'a>)=
    match tree with
    | Node(ls,rs,_) -> (ls.Depth < ( rs.Depth + 1))
    | _ -> false

let ppp (tree:Tree<'a>)=
    match tree with
    | Node(ls,rs,_) when pp tree -> match rs with
                                    | Node(rls,rrs,_) when rls.Depth < rrs.Depth -> true
                                    | _ -> false
    | _ ->false 
    
let ppm (tree:Tree<'a>)=
    match tree with
    | Node(ls,rs,_) when pp tree -> match rs with
                                    | Node(rls,rrs,_) when rls.Depth > rrs.Depth -> true
                                    | _ -> false
    | _ ->false 
    
let rec invertTree (tree:Tree<'a>)=
    match tree with
    | (Node(ls,rs,x))-> Node(invertTree rs,invertTree ls,x)
    | _ -> tree


let rec reBalance (tree:Tree<'a>)=
    match tree with
    | Node(ls,rs,x) when (not (avlProperty tree)) && (ppp tree || ppm tree)-> 
        match rs with
            | Node(rls,rrs,y) when ppp tree-> Node(Node(ls,rls,x),rrs,y)
            | Node(Node(rlls,rlrs,z),rrs,y) when ppm tree-> Node(Node(ls,rlls,x),Node(rlrs,rrs,y),z)
            | _ -> failwith "Valamilyen hiba történt"
    | _ when (not (avlProperty tree)) &&(ppp (invertTree tree) || ppm (invertTree tree)) -> (invertTree (reBalance (invertTree tree)))
    | _ -> tree
    
let rec insertValue value (tree:Tree<'a>)=
    match tree with
    | Node(ls,rs,x) when value<x -> Node(insertValue value ls,rs,x)
    | Node(ls,rs,x) when value>x -> Node(ls,insertValue value rs,x)
    | Leaf                       -> Node(Leaf,Leaf,value)
    | _ -> failwith "az ertek mar szerepelt"

let szam tree=
    match tree with
    | Node(_,_,x) ->x
    | Leaf -> 0
    

let rec showChildren tree value=
    match tree with
    | Node(l,r,x) when value=x -> (x,szam l , szam r)
    | Node(l,r,x) when value<x -> showChildren l value
    | Node(l,r,x) when value>x -> showChildren r value
    | _ -> failwith "Nincs a fában gyereke"
    


let safeInsert value (tree:Tree<'a>)= reBalance (insertValue value tree)

let tesztFa = safeInsert 3 Leaf |> safeInsert 10 |> safeInsert 15 |> safeInsert 20 |> safeInsert 1 |> safeInsert 18 |> safeInsert 17 |> safeInsert 25 |> safeInsert 22 |> safeInsert 21 |> safeInsert 30
printfn "Beszúrt értékek: 3 10 15 20 1 18 17 25 22 21 30"
printfn ""
printfn "teszt  10 gyerekei %A" (showChildren tesztFa 10)
printfn "teszt  15 gyerekei %A" (showChildren tesztFa 15)
printfn "teszt  3 gyerekei %A" (showChildren tesztFa 3)
printfn "teszt  1 gyerekei %A" (showChildren tesztFa 1)
printfn "teszt  20 gyerekei %A" (showChildren tesztFa 20)
printfn "teszt  30 gyerekei %A" (showChildren tesztFa 30)
printfn "Avl tulajdonságú-e a fa: %A" (avlProperty tesztFa)
    

//Létrehozunk egy új típust mely garantálja hogy csak biztonságos beszúrás lehet rajta

type AVLTree<'a>()=
    let mutable fa:Tree<'a>=Leaf
    member x.Depth = fa.Depth
    member x.Insert(value:'a)= fa <- safeInsert value fa
    member x.Get = fa



let tesztFa2:AVLTree<int>= AVLTree()

tesztFa2.Insert(5)
tesztFa2.Insert(1)
tesztFa2.Insert(2)
tesztFa2.Insert(3)
tesztFa2.Insert(4)
tesztFa2.Insert(6)

printfn "tesztfa2: %A" tesztFa2.Get
printfn "Avl tulajdonságú-e a fa? %A" (avlProperty tesztFa2.Get)


System.Console.ReadKey () |> ignore
